/*
 *  Copyright 2012 Alexey Andreev.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.teavm.parsing;

import java.io.InputStream;

/**
 *
 * @author Alexey Andreev
 */
public class ClasspathResourceProvider implements ResourceProvider {
    private ClassLoader classLoader;

    public ClasspathResourceProvider(ClassLoader classLoader) {
        this.classLoader = classLoader;
    }

    @Override
    public boolean hasResource(String name) {
        return classLoader.getResource(name) != null;
    }

    @Override
    public InputStream openResource(String name) {
        return classLoader.getResourceAsStream(name);
    }
}
